#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/keysym.h>
#include <X11/extensions/XTest.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int
whosthere(Display *dpy, Window w)
{
	XTextProperty prop;

	if (!XGetTextProperty(dpy, w, &prop, XA_WM_NAME))
		return 0;
	if (strstr(prop.value, "Mozilla Firefox"))
		return 1;
	if (strstr(prop.value, "VIM"))
		return 2;
	return 3;
}

void
undo(Display *dpy, Window w, int reallyredo)
{
	KeySym keysym;
	KeyCode keycode, ctrlcode, shiftcode;

	ctrlcode = XKeysymToKeycode(dpy, XK_Control_L);
	shiftcode = XKeysymToKeycode(dpy, XK_Shift_L);

	switch (whosthere(dpy, w)) {
	case 1:
		keysym = 'Z';
		keycode = XKeysymToKeycode(dpy, keysym);
		if (reallyredo)
			XTestFakeKeyEvent(dpy, shiftcode, True, 0);
		XTestFakeKeyEvent(dpy, keycode, True, 0);
		XTestFakeKeyEvent(dpy, keycode, False, 0);
		if (reallyredo)
			XTestFakeKeyEvent(dpy, shiftcode, False, 0);
		break;
	case 2:
		if (reallyredo) {
			keysym = 'r';
			keycode = XKeysymToKeycode(dpy, keysym);
			XTestFakeKeyEvent(dpy, keycode, True, 0);
			XTestFakeKeyEvent(dpy, keycode, False, 0);
		} else {
			keysym = 'u';
			keycode = XKeysymToKeycode(dpy, keysym);
			XTestFakeKeyEvent(dpy, ctrlcode, False, 0);
			XTestFakeKeyEvent(dpy, keycode, True, 0);
			XTestFakeKeyEvent(dpy, keycode, False, 0);
			XTestFakeKeyEvent(dpy, ctrlcode, True, 0);
		}
		break;
	case 3:
		keysym = reallyredo ? XK_Down : XK_Up;
		keycode = XKeysymToKeycode(dpy, keysym);
		XTestFakeKeyEvent(dpy, ctrlcode, False, 0);
		XTestFakeKeyEvent(dpy, keycode, True, 0);
		XTestFakeKeyEvent(dpy, keycode, False, 0);
		XTestFakeKeyEvent(dpy, ctrlcode, True, 0);
		break;
	default:
		break;
	}

}

int
main(int argc, char **argv)
{
	Display *dpy = XOpenDisplay(NULL);
	int screen = DefaultScreen(dpy);
	Window root = RootWindow(dpy, screen);
	XEvent ev;

	unsigned int modifiers = ControlMask;
	Bool ownerevents = False;
	unsigned int eventmask = ButtonPressMask;
	int pointermode = GrabModeAsync;
	int keyboardmode = GrabModeAsync;
	Window confine = 0;
	Cursor cursor = 0;

	XGrabButton(dpy, 4, modifiers, root, ownerevents, eventmask,
	    pointermode, keyboardmode, confine, cursor);
	XGrabButton(dpy, 5, modifiers, root, ownerevents, eventmask,
	    pointermode, keyboardmode, confine, cursor);
	while (1) {
		XNextEvent(dpy, &ev);
		switch (ev.type) {
		case ButtonPress:
			switch (ev.xbutton.button) {
			case 4:
				undo(dpy, ev.xbutton.subwindow, 0);
				break;
			case 5:
				undo(dpy, ev.xbutton.subwindow, 1);
				break;
			}
		}
	}
	return 0;
}

